<center><a href="binv.c">Actual source code: binv.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:17:13+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSC_DLL</font></strong>
<a name="line2"> 2: </a> #include <A href="../../../../../src/sys/viewer/viewerimpl.h.html">src/sys/viewer/viewerimpl.h</A>
<a name="line3"> 3: </a> #include <A href="../../../../../include/petscsys.h.html">petscsys.h</A>
<a name="line4">  4: </a><font color="#A020F0">#include &lt;fcntl.h&gt;</font>
<a name="line5">  5: </a><font color="#A020F0">#if defined(PETSC_HAVE_UNISTD_H)</font>
<a name="line6">  6: </a><font color="#A020F0">#include &lt;unistd.h&gt;</font>
<a name="line7">  7: </a><font color="#A020F0">#endif</font>
<a name="line8">  8: </a><font color="#A020F0">#if defined (PETSC_HAVE_IO_H)</font>
<a name="line9">  9: </a><font color="#A020F0">#include &lt;io.h&gt;</font>
<a name="line10"> 10: </a><font color="#A020F0">#endif</font>

<a name="line12"> 12: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font>  {
<a name="line13"> 13: </a>  int           fdes;            <font color="#B22222">/* file descriptor */</font>
<a name="line14"> 14: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A> btype;           <font color="#B22222">/* read or write? */</font>
<a name="line15"> 15: </a>  FILE          *fdes_info;      <font color="#B22222">/* optional file containing info on binary file*/</font>
<a name="line16"> 16: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>    storecompressed; <font color="#B22222">/* gzip the write binary file when closing it*/</font>
<a name="line17"> 17: </a>  char          *filename;
<a name="line18"> 18: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>    skipinfo;        <font color="#B22222">/* Don't create info file for writing; don't use for reading */</font>
<a name="line19"> 19: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>    skipoptions;     <font color="#B22222">/* don't use PETSc options database when loading */</font>
<a name="line20"> 20: </a>} PetscViewer_Binary;

<a name="line24"> 24: </a><strong><font color="#4169E1"><a name="PetscViewerGetSingleton_Binary"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscViewerGetSingleton_Binary(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> *outviewer)</font></strong>
<a name="line25"> 25: </a>{
<a name="line26"> 26: </a>  int                <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line27"> 27: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>     ierr;
<a name="line28"> 28: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data,*obinary;

<a name="line31"> 31: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(viewer-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line32"> 32: </a>  <font color="#4169E1">if</font> (!<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>) {
<a name="line33"> 33: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerCreate.html#PetscViewerCreate">PetscViewerCreate</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,outviewer);
<a name="line34"> 34: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetType.html#PetscViewerSetType">PetscViewerSetType</A>(*outviewer,PETSC_VIEWER_BINARY);
<a name="line35"> 35: </a>    obinary = (PetscViewer_Binary*)(*outviewer)-&gt;data;
<a name="line36"> 36: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(obinary,vbinary,<font color="#4169E1">sizeof</font>(PetscViewer_Binary));
<a name="line37"> 37: </a>  } <font color="#4169E1">else</font> {
<a name="line38"> 38: </a>    *outviewer = 0;
<a name="line39"> 39: </a>  }
<a name="line40"> 40: </a>  <font color="#4169E1">return</font>(0);
<a name="line41"> 41: </a>}

<a name="line45"> 45: </a><strong><font color="#4169E1"><a name="PetscViewerRestoreSingleton_Binary"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscViewerRestoreSingleton_Binary(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> *outviewer)</font></strong>
<a name="line46"> 46: </a>{
<a name="line48"> 48: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;

<a name="line51"> 51: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(viewer-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line52"> 52: </a>  <font color="#4169E1">if</font> (!<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>) {
<a name="line53"> 53: </a>    <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>((*outviewer)-&gt;data);
<a name="line54"> 54: </a>    PetscHeaderDestroy(*outviewer);
<a name="line55"> 55: </a>  }
<a name="line56"> 56: </a>  <font color="#4169E1">return</font>(0);
<a name="line57"> 57: </a>}

<a name="line61"> 61: </a><font color="#B22222">/*@C</font>
<a name="line62"> 62: </a><font color="#B22222">    <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A> - Extracts the file descriptor from a <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>.</font>

<a name="line64"> 64: </a><font color="#B22222">    Not Collective</font>

<a name="line66"> 66: </a><font color="#B22222">+   viewer - <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> context, obtained from <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>()</font>
<a name="line67"> 67: </a><font color="#B22222">-   fdes - file descriptor</font>

<a name="line69"> 69: </a><font color="#B22222">    Level: advanced</font>

<a name="line71"> 71: </a><font color="#B22222">    Notes:</font>
<a name="line72"> 72: </a><font color="#B22222">      For writable binary <A href="../../../../../docs/manualpages/Viewer/PetscViewers.html#PetscViewers">PetscViewers</A>, the descriptor will only be valid for the </font>
<a name="line73"> 73: </a><font color="#B22222">    first processor in the communicator that shares the <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>. For readable </font>
<a name="line74"> 74: </a><font color="#B22222">    files it will only be valid on nodes that have the file. If node 0 does not</font>
<a name="line75"> 75: </a><font color="#B22222">    have the file it generates an error even if another node does have the file.</font>
<a name="line76"> 76: </a><font color="#B22222"> </font>
<a name="line77"> 77: </a><font color="#B22222">    Fortran Note:</font>
<a name="line78"> 78: </a><font color="#B22222">    This routine is not supported in Fortran.</font>

<a name="line80"> 80: </a><font color="#B22222">  Concepts: file descriptor^getting</font>
<a name="line81"> 81: </a><font color="#B22222">  Concepts: PetscViewerBinary^accessing file descriptor</font>

<a name="line83"> 83: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(),<A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetInfoPointer.html#PetscViewerBinaryGetInfoPointer">PetscViewerBinaryGetInfoPointer</A>()</font>
<a name="line84"> 84: </a><font color="#B22222">@*/</font>
<a name="line85"> 85: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryGetDescriptor"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,int *fdes)</font></strong>
<a name="line86"> 86: </a>{
<a name="line87"> 87: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line90"> 90: </a>  *fdes = vbinary-&gt;fdes;
<a name="line91"> 91: </a>  <font color="#4169E1">return</font>(0);
<a name="line92"> 92: </a>}

<a name="line96"> 96: </a><font color="#B22222">/*@</font>
<a name="line97"> 97: </a><font color="#B22222">    <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinarySkipInfo.html#PetscViewerBinarySkipInfo">PetscViewerBinarySkipInfo</A> - Binary file will not have .info file created with it</font>

<a name="line99"> 99: </a><font color="#B22222">    Not Collective</font>

<a name="line101">101: </a><font color="#B22222">    Input Paramter:</font>
<a name="line102">102: </a><font color="#B22222">.   viewer - <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> context, obtained from <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>()</font>

<a name="line104">104: </a><font color="#B22222">    Options Database Key:</font>
<a name="line105">105: </a><font color="#B22222">.   -viewer_binary_skip_info</font>

<a name="line107">107: </a><font color="#B22222">    Level: advanced</font>

<a name="line109">109: </a><font color="#B22222">    Notes: This must be called after <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetType.html#PetscViewerSetType">PetscViewerSetType</A>() but before PetscViewerBinarySetFilename()</font>

<a name="line111">111: </a><font color="#B22222">   Concepts: PetscViewerBinary^accessing info file</font>

<a name="line113">113: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinarySetSkipOptions.html#PetscViewerBinarySetSkipOptions">PetscViewerBinarySetSkipOptions</A>(),</font>
<a name="line114">114: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetSkipOptions.html#PetscViewerBinaryGetSkipOptions">PetscViewerBinaryGetSkipOptions</A>()</font>
<a name="line115">115: </a><font color="#B22222">@*/</font>
<a name="line116">116: </a><strong><font color="#4169E1"><a name="PetscViewerBinarySkipInfo"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinarySkipInfo.html#PetscViewerBinarySkipInfo">PetscViewerBinarySkipInfo</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line117">117: </a>{
<a name="line118">118: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line121">121: </a>  vbinary-&gt;skipinfo = <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line122">122: </a>  <font color="#4169E1">return</font>(0);
<a name="line123">123: </a>}

<a name="line127">127: </a><font color="#B22222">/*@</font>
<a name="line128">128: </a><font color="#B22222">    <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinarySetSkipOptions.html#PetscViewerBinarySetSkipOptions">PetscViewerBinarySetSkipOptions</A> - do not use the PETSc options database when loading objects</font>

<a name="line130">130: </a><font color="#B22222">    Not Collective</font>

<a name="line132">132: </a><font color="#B22222">    Input Paramter:</font>
<a name="line133">133: </a><font color="#B22222">+   viewer - <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> context, obtained from <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>()</font>
<a name="line134">134: </a><font color="#B22222">-   skip - <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A> means do not use</font>

<a name="line136">136: </a><font color="#B22222">    Options Database Key:</font>
<a name="line137">137: </a><font color="#B22222">.   -viewer_binary_skip_options</font>

<a name="line139">139: </a><font color="#B22222">    Level: advanced</font>

<a name="line141">141: </a><font color="#B22222">    Notes: This must be called after <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetType.html#PetscViewerSetType">PetscViewerSetType</A>()</font>

<a name="line143">143: </a><font color="#B22222">   Concepts: PetscViewerBinary^accessing info file</font>

<a name="line145">145: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinarySkipInfo.html#PetscViewerBinarySkipInfo">PetscViewerBinarySkipInfo</A>(),</font>
<a name="line146">146: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetSkipOptions.html#PetscViewerBinaryGetSkipOptions">PetscViewerBinaryGetSkipOptions</A>()</font>
<a name="line147">147: </a><font color="#B22222">@*/</font>
<a name="line148">148: </a><strong><font color="#4169E1"><a name="PetscViewerBinarySetSkipOptions"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinarySetSkipOptions.html#PetscViewerBinarySetSkipOptions">PetscViewerBinarySetSkipOptions</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> skip)</font></strong>
<a name="line149">149: </a>{
<a name="line150">150: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line153">153: </a>  vbinary-&gt;skipoptions = skip;
<a name="line154">154: </a>  <font color="#4169E1">return</font>(0);
<a name="line155">155: </a>}

<a name="line159">159: </a><font color="#B22222">/*@</font>
<a name="line160">160: </a><font color="#B22222">    <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetSkipOptions.html#PetscViewerBinaryGetSkipOptions">PetscViewerBinaryGetSkipOptions</A> - checks if viewer uses the PETSc options database when loading objects</font>

<a name="line162">162: </a><font color="#B22222">    Not Collective</font>

<a name="line164">164: </a><font color="#B22222">    Input Paramter:</font>
<a name="line165">165: </a><font color="#B22222">.   viewer - <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> context, obtained from <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>()</font>

<a name="line167">167: </a><font color="#B22222">    Output Parameter:</font>
<a name="line168">168: </a><font color="#B22222">.   skip - <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A> means do not use</font>

<a name="line170">170: </a><font color="#B22222">    Level: advanced</font>

<a name="line172">172: </a><font color="#B22222">    Notes: This must be called after <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetType.html#PetscViewerSetType">PetscViewerSetType</A>()</font>

<a name="line174">174: </a><font color="#B22222">   Concepts: PetscViewerBinary^accessing info file</font>

<a name="line176">176: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinarySkipInfo.html#PetscViewerBinarySkipInfo">PetscViewerBinarySkipInfo</A>(),</font>
<a name="line177">177: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinarySetSkipOptions.html#PetscViewerBinarySetSkipOptions">PetscViewerBinarySetSkipOptions</A>()</font>
<a name="line178">178: </a><font color="#B22222">@*/</font>
<a name="line179">179: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryGetSkipOptions"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetSkipOptions.html#PetscViewerBinaryGetSkipOptions">PetscViewerBinaryGetSkipOptions</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> *skip)</font></strong>
<a name="line180">180: </a>{
<a name="line181">181: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line184">184: </a>  *skip = vbinary-&gt;skipoptions;
<a name="line185">185: </a>  <font color="#4169E1">return</font>(0);
<a name="line186">186: </a>}

<a name="line190">190: </a><font color="#B22222">/*@C</font>
<a name="line191">191: </a><font color="#B22222">    <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetInfoPointer.html#PetscViewerBinaryGetInfoPointer">PetscViewerBinaryGetInfoPointer</A> - Extracts the file pointer for the ASCII</font>
<a name="line192">192: </a><font color="#B22222">          info file associated with a binary file.</font>

<a name="line194">194: </a><font color="#B22222">    Not Collective</font>

<a name="line196">196: </a><font color="#B22222">+   viewer - <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> context, obtained from <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>()</font>
<a name="line197">197: </a><font color="#B22222">-   file - file pointer</font>

<a name="line199">199: </a><font color="#B22222">    Level: advanced</font>

<a name="line201">201: </a><font color="#B22222">    Notes:</font>
<a name="line202">202: </a><font color="#B22222">      For writable binary <A href="../../../../../docs/manualpages/Viewer/PetscViewers.html#PetscViewers">PetscViewers</A>, the descriptor will only be valid for the </font>
<a name="line203">203: </a><font color="#B22222">    first processor in the communicator that shares the <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>.</font>
<a name="line204">204: </a><font color="#B22222"> </font>
<a name="line205">205: </a><font color="#B22222">    Fortran Note:</font>
<a name="line206">206: </a><font color="#B22222">    This routine is not supported in Fortran.</font>

<a name="line208">208: </a><font color="#B22222">  Concepts: PetscViewerBinary^accessing info file</font>

<a name="line210">210: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(),<A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>()</font>
<a name="line211">211: </a><font color="#B22222">@*/</font>
<a name="line212">212: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryGetInfoPointer"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetInfoPointer.html#PetscViewerBinaryGetInfoPointer">PetscViewerBinaryGetInfoPointer</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,FILE **file)</font></strong>
<a name="line213">213: </a>{
<a name="line214">214: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line217">217: </a>  *file = vbinary-&gt;fdes_info;
<a name="line218">218: </a>  <font color="#4169E1">return</font>(0);
<a name="line219">219: </a>}

<a name="line223">223: </a><strong><font color="#4169E1"><a name="PetscViewerDestroy_Binary"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscViewerDestroy_Binary(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> v)</font></strong>
<a name="line224">224: </a>{
<a name="line225">225: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)v-&gt;data;
<a name="line226">226: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>     ierr;
<a name="line227">227: </a>  int                <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;

<a name="line230">230: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(v-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line231">231: </a>  <font color="#4169E1">if</font> ((!<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> || vbinary-&gt;btype == FILE_MODE_READ) &amp;&amp; vbinary-&gt;fdes) {
<a name="line232">232: </a>    close(vbinary-&gt;fdes);
<a name="line233">233: </a>    <font color="#4169E1">if</font> (!<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> &amp;&amp; vbinary-&gt;storecompressed) {
<a name="line234">234: </a>      char par[PETSC_MAX_PATH_LEN],buf[PETSC_MAX_PATH_LEN];
<a name="line235">235: </a>      FILE *fp;
<a name="line236">236: </a>      <font color="#B22222">/* compress the file */</font>
<a name="line237">237: </a>      <A href="../../../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(par,<font color="#666666">"gzip "</font>);
<a name="line238">238: </a>      <A href="../../../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(par,vbinary-&gt;filename);
<a name="line239">239: </a><font color="#A020F0">#if defined(PETSC_HAVE_POPEN)</font>
<a name="line240">240: </a>      <A href="../../../../../docs/manualpages/Sys/PetscPOpen.html#PetscPOpen">PetscPOpen</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,par,<font color="#666666">"r"</font>,&amp;fp);
<a name="line241">241: </a>      <font color="#4169E1">if</font> (fgets(buf,1024,fp)) {
<a name="line242">242: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ2.html#SETERRQ2">SETERRQ2</A>(PETSC_ERR_LIB,<font color="#666666">"Error from command %s\n%s"</font>,par,buf);
<a name="line243">243: </a>      }
<a name="line244">244: </a>      <A href="../../../../../docs/manualpages/Sys/PetscPClose.html#PetscPClose">PetscPClose</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,fp);
<a name="line245">245: </a><font color="#A020F0">#else</font>
<a name="line246">246: </a>      <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_SUP_SYS,<font color="#666666">"Cannot run external programs on this machine"</font>);
<a name="line247">247: </a><font color="#A020F0">#endif</font>
<a name="line248">248: </a>    }
<a name="line249">249: </a>  }
<a name="line250">250: </a>  <font color="#4169E1">if</font> (vbinary-&gt;fdes_info) fclose(vbinary-&gt;fdes_info);
<a name="line251">251: </a>  <A href="../../../../../docs/manualpages/Sys/PetscStrfree.html#PetscStrfree">PetscStrfree</A>(vbinary-&gt;filename);
<a name="line252">252: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(vbinary);
<a name="line253">253: </a>  <font color="#4169E1">return</font>(0);
<a name="line254">254: </a>}

<a name="line258">258: </a><font color="#B22222">/*@</font>
<a name="line259">259: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryCreate.html#PetscViewerBinaryCreate">PetscViewerBinaryCreate</A> - Create a binary viewer.</font>

<a name="line261">261: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A></font>

<a name="line263">263: </a><font color="#B22222">   Input Parameters:</font>
<a name="line264">264: </a><font color="#B22222">.  <A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A> - MPI communicator</font>

<a name="line266">266: </a><font color="#B22222">   Output Parameter:</font>
<a name="line267">267: </a><font color="#B22222">.  binv - <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> for binary input/output</font>

<a name="line269">269: </a><font color="#B22222">   Level: beginner</font>
<a name="line270">270: </a><font color="#B22222">@*/</font>
<a name="line271">271: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryCreate"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryCreate.html#PetscViewerBinaryCreate">PetscViewerBinaryCreate</A>(<A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A> <A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> *binv)</font></strong>
<a name="line272">272: </a>{
<a name="line274">274: </a>
<a name="line276">276: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerCreate.html#PetscViewerCreate">PetscViewerCreate</A>(<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,binv);
<a name="line277">277: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetType.html#PetscViewerSetType">PetscViewerSetType</A>(*binv,PETSC_VIEWER_BINARY);
<a name="line278">278: </a>  <font color="#4169E1">return</font>(0);
<a name="line279">279: </a>}

<a name="line283">283: </a><font color="#B22222">/*@C</font>
<a name="line284">284: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A> - Opens a file for binary input/output.</font>

<a name="line286">286: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A></font>

<a name="line288">288: </a><font color="#B22222">   Input Parameters:</font>
<a name="line289">289: </a><font color="#B22222">+  <A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A> - MPI communicator</font>
<a name="line290">290: </a><font color="#B22222">.  name - name of file </font>
<a name="line291">291: </a><font color="#B22222">-  type - type of file</font>
<a name="line292">292: </a><font color="#B22222">$    FILE_MODE_WRITE - create new file for binary output</font>
<a name="line293">293: </a><font color="#B22222">$    FILE_MODE_READ - open existing file for binary input</font>
<a name="line294">294: </a><font color="#B22222">$    FILE_MODE_APPEND - open existing file for binary output</font>

<a name="line296">296: </a><font color="#B22222">   Output Parameter:</font>
<a name="line297">297: </a><font color="#B22222">.  binv - <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> for binary input/output to use with the specified file</font>

<a name="line299">299: </a><font color="#B22222">   Level: beginner</font>

<a name="line301">301: </a><font color="#B22222">   Note:</font>
<a name="line302">302: </a><font color="#B22222">   This <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> should be destroyed with <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>().</font>

<a name="line304">304: </a><font color="#B22222">    For reading files, the filename may begin with ftp:// or http:// and/or</font>
<a name="line305">305: </a><font color="#B22222">    end with .gz; in this case file is brought over and uncompressed.</font>

<a name="line307">307: </a><font color="#B22222">    For creating files, if the file name ends with .gz it is automatically </font>
<a name="line308">308: </a><font color="#B22222">    compressed when closed.</font>

<a name="line310">310: </a><font color="#B22222">    For writing files it only opens the file on processor 0 in the communicator.</font>
<a name="line311">311: </a><font color="#B22222">    For readable files it opens the file on all nodes that have the file. If </font>
<a name="line312">312: </a><font color="#B22222">    node 0 does not have the file it generates an error even if other nodes</font>
<a name="line313">313: </a><font color="#B22222">    do have the file.</font>

<a name="line315">315: </a><font color="#B22222">   Concepts: binary files</font>
<a name="line316">316: </a><font color="#B22222">   Concepts: PetscViewerBinary^creating</font>
<a name="line317">317: </a><font color="#B22222">   Concepts: gzip</font>
<a name="line318">318: </a><font color="#B22222">   Concepts: accessing remote file</font>
<a name="line319">319: </a><font color="#B22222">   Concepts: remote file</font>

<a name="line321">321: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIOpen.html#PetscViewerASCIIOpen">PetscViewerASCIIOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetFormat.html#PetscViewerSetFormat">PetscViewerSetFormat</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(),</font>
<a name="line322">322: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(), <A href="../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(), <A href="../../../../../docs/manualpages/Vec/VecLoad.html#VecLoad">VecLoad</A>(), <A href="../../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>(),</font>
<a name="line323">323: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetInfoPointer.html#PetscViewerBinaryGetInfoPointer">PetscViewerBinaryGetInfoPointer</A>(), <A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A>, <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>, <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryRead.html#PetscViewerBinaryRead">PetscViewerBinaryRead</A>()</font>
<a name="line324">324: </a><font color="#B22222">@*/</font>
<a name="line325">325: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryOpen"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(<A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A> <A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,const char name[],<A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A> type,<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> *binv)</font></strong>
<a name="line326">326: </a>{
<a name="line328">328: </a>
<a name="line330">330: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerCreate.html#PetscViewerCreate">PetscViewerCreate</A>(<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,binv);
<a name="line331">331: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetType.html#PetscViewerSetType">PetscViewerSetType</A>(*binv,PETSC_VIEWER_BINARY);
<a name="line332">332: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileSetMode.html#PetscViewerFileSetMode">PetscViewerFileSetMode</A>(*binv,type);
<a name="line333">333: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileSetName.html#PetscViewerFileSetName">PetscViewerFileSetName</A>(*binv,name);
<a name="line334">334: </a>  <font color="#4169E1">return</font>(0);
<a name="line335">335: </a>}

<a name="line339">339: </a><font color="#B22222">/*@C</font>
<a name="line340">340: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryRead.html#PetscViewerBinaryRead">PetscViewerBinaryRead</A> - Reads from a binary file, all processors get the same result</font>

<a name="line342">342: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A></font>

<a name="line344">344: </a><font color="#B22222">   Input Parameters:</font>
<a name="line345">345: </a><font color="#B22222">+  viewer - the binary viewer</font>
<a name="line346">346: </a><font color="#B22222">.  data - location to write the data</font>
<a name="line347">347: </a><font color="#B22222">.  count - number of items of data to read</font>
<a name="line348">348: </a><font color="#B22222">-  datatype - type of data to read</font>

<a name="line350">350: </a><font color="#B22222">   Level: beginner</font>

<a name="line352">352: </a><font color="#B22222">   Concepts: binary files</font>

<a name="line354">354: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIOpen.html#PetscViewerASCIIOpen">PetscViewerASCIIOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetFormat.html#PetscViewerSetFormat">PetscViewerSetFormat</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(),</font>
<a name="line355">355: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(), <A href="../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(), <A href="../../../../../docs/manualpages/Vec/VecLoad.html#VecLoad">VecLoad</A>(), <A href="../../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>(),</font>
<a name="line356">356: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetInfoPointer.html#PetscViewerBinaryGetInfoPointer">PetscViewerBinaryGetInfoPointer</A>(), <A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A>, <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>, PetscBinaryViewerRead()</font>
<a name="line357">357: </a><font color="#B22222">@*/</font>
<a name="line358">358: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryRead"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryRead.html#PetscViewerBinaryRead">PetscViewerBinaryRead</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,void *data,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> count,<A href="../../../../../docs/manualpages/Sys/PetscDataType.html#PetscDataType">PetscDataType</A> dtype)</font></strong>
<a name="line359">359: </a>{
<a name="line360">360: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>     ierr;
<a name="line361">361: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line363">363: </a>  <A href="../../../../../docs/manualpages/Sys/PetscSynchronizedBinaryRead.html#PetscSynchronizedBinaryRead">PetscSynchronizedBinaryRead</A>(viewer-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,vbinary-&gt;fdes,data,count,dtype);
<a name="line364">364: </a>  <font color="#4169E1">return</font>(0);
<a name="line365">365: </a>}

<a name="line369">369: </a><font color="#B22222">/*@C</font>
<a name="line370">370: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryWrite.html#PetscViewerBinaryWrite">PetscViewerBinaryWrite</A> - writes to a binary file, only from the first process</font>

<a name="line372">372: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A></font>

<a name="line374">374: </a><font color="#B22222">   Input Parameters:</font>
<a name="line375">375: </a><font color="#B22222">+  viewer - the binary viewer</font>
<a name="line376">376: </a><font color="#B22222">.  data - location of data</font>
<a name="line377">377: </a><font color="#B22222">.  count - number of items of data to read</font>
<a name="line378">378: </a><font color="#B22222">.  istemp - data may be overwritten</font>
<a name="line379">379: </a><font color="#B22222">-  datatype - type of data to read</font>

<a name="line381">381: </a><font color="#B22222">   Level: beginner</font>

<a name="line383">383: </a><font color="#B22222">   Concepts: binary files</font>

<a name="line385">385: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIOpen.html#PetscViewerASCIIOpen">PetscViewerASCIIOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetFormat.html#PetscViewerSetFormat">PetscViewerSetFormat</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(),</font>
<a name="line386">386: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(), <A href="../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(), <A href="../../../../../docs/manualpages/Vec/VecLoad.html#VecLoad">VecLoad</A>(), <A href="../../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>(),</font>
<a name="line387">387: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetInfoPointer.html#PetscViewerBinaryGetInfoPointer">PetscViewerBinaryGetInfoPointer</A>(), <A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A>, <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>, PetscBinaryViewerRead()</font>
<a name="line388">388: </a><font color="#B22222">@*/</font>
<a name="line389">389: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryWrite"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryWrite.html#PetscViewerBinaryWrite">PetscViewerBinaryWrite</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,void *data,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> count,<A href="../../../../../docs/manualpages/Sys/PetscDataType.html#PetscDataType">PetscDataType</A> dtype,<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> istemp)</font></strong>
<a name="line390">390: </a>{
<a name="line391">391: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>     ierr;
<a name="line392">392: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line394">394: </a>  <A href="../../../../../docs/manualpages/Sys/PetscSynchronizedBinaryWrite.html#PetscSynchronizedBinaryWrite">PetscSynchronizedBinaryWrite</A>(viewer-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,vbinary-&gt;fdes,data,count,dtype,istemp);
<a name="line395">395: </a>  <font color="#4169E1">return</font>(0);
<a name="line396">396: </a>}

<a name="line400">400: </a><font color="#B22222">/*@C</font>
<a name="line401">401: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryWriteStringArray.html#PetscViewerBinaryWriteStringArray">PetscViewerBinaryWriteStringArray</A> - writes to a binary file, only from the first process an array of strings</font>

<a name="line403">403: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A></font>

<a name="line405">405: </a><font color="#B22222">   Input Parameters:</font>
<a name="line406">406: </a><font color="#B22222">+  viewer - the binary viewer</font>
<a name="line407">407: </a><font color="#B22222">-  data - location of the array of strings</font>


<a name="line410">410: </a><font color="#B22222">   Level: intermediate</font>

<a name="line412">412: </a><font color="#B22222">   Concepts: binary files</font>

<a name="line414">414: </a><font color="#B22222">    Notes: array of strings is null terminated</font>

<a name="line416">416: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIOpen.html#PetscViewerASCIIOpen">PetscViewerASCIIOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetFormat.html#PetscViewerSetFormat">PetscViewerSetFormat</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(),</font>
<a name="line417">417: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(), <A href="../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(), <A href="../../../../../docs/manualpages/Vec/VecLoad.html#VecLoad">VecLoad</A>(), <A href="../../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>(),</font>
<a name="line418">418: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetInfoPointer.html#PetscViewerBinaryGetInfoPointer">PetscViewerBinaryGetInfoPointer</A>(), <A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A>, <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>, PetscBinaryViewerRead()</font>
<a name="line419">419: </a><font color="#B22222">@*/</font>
<a name="line420">420: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryWriteStringArray"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryWriteStringArray.html#PetscViewerBinaryWriteStringArray">PetscViewerBinaryWriteStringArray</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,char **data)</font></strong>
<a name="line421">421: </a>{
<a name="line422">422: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>     ierr;
<a name="line423">423: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>           i,n = 0,*sizes;

<a name="line425">425: </a>  <font color="#B22222">/* count number of strings */</font>
<a name="line426">426: </a>  <font color="#4169E1">while</font> (data[n++]);
<a name="line427">427: </a>  n--;
<a name="line428">428: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((n+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;sizes);
<a name="line429">429: </a>  sizes[0] = n;
<a name="line430">430: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line431">431: </a>    size_t tmp;
<a name="line432">432: </a>    <A href="../../../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(data[i],&amp;tmp);
<a name="line433">433: </a>    sizes[i+1] = tmp + 1;   <font color="#B22222">/* <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> includes space for the null terminator */</font>
<a name="line434">434: </a>  }
<a name="line435">435: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryWrite.html#PetscViewerBinaryWrite">PetscViewerBinaryWrite</A>(viewer,sizes,n+1,PETSC_INT,<A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>);
<a name="line436">436: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line437">437: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryWrite.html#PetscViewerBinaryWrite">PetscViewerBinaryWrite</A>(viewer,data[i],sizes[i+1],PETSC_CHAR,<A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>);
<a name="line438">438: </a>  }
<a name="line439">439: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(sizes);
<a name="line440">440: </a>  <font color="#4169E1">return</font>(0);
<a name="line441">441: </a>}

<a name="line443">443: </a><font color="#B22222">/*@C</font>
<a name="line444">444: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryReadStringArray.html#PetscViewerBinaryReadStringArray">PetscViewerBinaryReadStringArray</A> - reads a binary file an array of strings</font>

<a name="line446">446: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A></font>

<a name="line448">448: </a><font color="#B22222">   Input Parameter:</font>
<a name="line449">449: </a><font color="#B22222">.  viewer - the binary viewer</font>

<a name="line451">451: </a><font color="#B22222">   Output Parameter:</font>
<a name="line452">452: </a><font color="#B22222">.  data - location of the array of strings</font>

<a name="line454">454: </a><font color="#B22222">   Level: intermediate</font>

<a name="line456">456: </a><font color="#B22222">   Concepts: binary files</font>

<a name="line458">458: </a><font color="#B22222">    Notes: array of strings is null terminated</font>

<a name="line460">460: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIOpen.html#PetscViewerASCIIOpen">PetscViewerASCIIOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetFormat.html#PetscViewerSetFormat">PetscViewerSetFormat</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(),</font>
<a name="line461">461: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(), <A href="../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(), <A href="../../../../../docs/manualpages/Vec/VecLoad.html#VecLoad">VecLoad</A>(), <A href="../../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetDescriptor.html#PetscViewerBinaryGetDescriptor">PetscViewerBinaryGetDescriptor</A>(),</font>
<a name="line462">462: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetInfoPointer.html#PetscViewerBinaryGetInfoPointer">PetscViewerBinaryGetInfoPointer</A>(), <A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A>, <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>, PetscBinaryViewerRead()</font>
<a name="line463">463: </a><font color="#B22222">@*/</font>
<a name="line464">464: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryReadStringArray"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryReadStringArray.html#PetscViewerBinaryReadStringArray">PetscViewerBinaryReadStringArray</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,char ***data)</font></strong>
<a name="line465">465: </a>{
<a name="line466">466: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>     ierr;
<a name="line467">467: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>           i,n,*sizes,N = 0;

<a name="line469">469: </a>  <font color="#B22222">/* count number of strings */</font>
<a name="line470">470: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryRead.html#PetscViewerBinaryRead">PetscViewerBinaryRead</A>(viewer,&amp;n,1,PETSC_INT);
<a name="line471">471: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(n*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;sizes);
<a name="line472">472: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryRead.html#PetscViewerBinaryRead">PetscViewerBinaryRead</A>(viewer,sizes,n,PETSC_INT);
<a name="line473">473: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line474">474: </a>    N += sizes[i];
<a name="line475">475: </a>  }
<a name="line476">476: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((n+1)*<font color="#4169E1">sizeof</font>(char*) + N*<font color="#4169E1">sizeof</font>(char),data);
<a name="line477">477: </a>  (*data)[0] = (char*)((*data) + n + 1);
<a name="line478">478: </a>  <font color="#4169E1">for</font> (i=1; i&lt;n; i++) {
<a name="line479">479: </a>    (*data)[i] = (*data)[i-1] + sizes[i-1];
<a name="line480">480: </a>  }
<a name="line481">481: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryRead.html#PetscViewerBinaryRead">PetscViewerBinaryRead</A>(viewer,(*data)[0],N,PETSC_CHAR);
<a name="line482">482: </a>  (*data)[n] = 0;
<a name="line483">483: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(sizes);
<a name="line484">484: </a>  <font color="#4169E1">return</font>(0);
<a name="line485">485: </a>}

<a name="line489">489: </a><font color="#B22222">/*@C</font>
<a name="line490">490: </a><font color="#B22222">     <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileGetMode.html#PetscViewerFileGetMode">PetscViewerFileGetMode</A> - Gets the type of file to be open</font>

<a name="line492">492: </a><font color="#B22222">    Collective on <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A></font>

<a name="line494">494: </a><font color="#B22222">  Input Parameter:</font>
<a name="line495">495: </a><font color="#B22222">.  viewer - the <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>; must be a binary, Matlab, hdf, or netcdf <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A></font>

<a name="line497">497: </a><font color="#B22222">  Output Parameter:</font>
<a name="line498">498: </a><font color="#B22222">.  type - type of file</font>
<a name="line499">499: </a><font color="#B22222">$    FILE_MODE_WRITE - create new file for binary output</font>
<a name="line500">500: </a><font color="#B22222">$    FILE_MODE_READ - open existing file for binary input</font>
<a name="line501">501: </a><font color="#B22222">$    FILE_MODE_APPEND - open existing file for binary output</font>

<a name="line503">503: </a><font color="#B22222">  Level: advanced</font>

<a name="line505">505: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileSetMode.html#PetscViewerFileSetMode">PetscViewerFileSetMode</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerCreate.html#PetscViewerCreate">PetscViewerCreate</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetType.html#PetscViewerSetType">PetscViewerSetType</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>()</font>

<a name="line507">507: </a><font color="#B22222">@*/</font>
<a name="line508">508: </a><strong><font color="#4169E1"><a name="PetscViewerFileGetMode"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileGetMode.html#PetscViewerFileGetMode">PetscViewerFileGetMode</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,<A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A> *type)</font></strong>
<a name="line509">509: </a>{
<a name="line510">510: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>,<A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A>*);

<a name="line515">515: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,<font color="#666666">"PetscViewerFileGetMode_C"</font>,(void (**)(void))&amp;f);
<a name="line516">516: </a>  <font color="#4169E1">if</font> (f) {
<a name="line517">517: </a>    (*f)(viewer,type);
<a name="line518">518: </a>  }
<a name="line519">519: </a>  <font color="#4169E1">return</font>(0);
<a name="line520">520: </a>}

<a name="line524">524: </a><font color="#B22222">/*@C</font>
<a name="line525">525: </a><font color="#B22222">     <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileSetMode.html#PetscViewerFileSetMode">PetscViewerFileSetMode</A> - Sets the type of file to be open</font>

<a name="line527">527: </a><font color="#B22222">    Collective on <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A></font>

<a name="line529">529: </a><font color="#B22222">  Input Parameters:</font>
<a name="line530">530: </a><font color="#B22222">+  viewer - the <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>; must be a binary, Matlab, hdf, or netcdf <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A></font>
<a name="line531">531: </a><font color="#B22222">-  type - type of file</font>
<a name="line532">532: </a><font color="#B22222">$    FILE_MODE_WRITE - create new file for binary output</font>
<a name="line533">533: </a><font color="#B22222">$    FILE_MODE_READ - open existing file for binary input</font>
<a name="line534">534: </a><font color="#B22222">$    FILE_MODE_APPEND - open existing file for binary output</font>

<a name="line536">536: </a><font color="#B22222">  Level: advanced</font>

<a name="line538">538: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileSetMode.html#PetscViewerFileSetMode">PetscViewerFileSetMode</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerCreate.html#PetscViewerCreate">PetscViewerCreate</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerSetType.html#PetscViewerSetType">PetscViewerSetType</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>()</font>

<a name="line540">540: </a><font color="#B22222">@*/</font>
<a name="line541">541: </a><strong><font color="#4169E1"><a name="PetscViewerFileSetMode"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileSetMode.html#PetscViewerFileSetMode">PetscViewerFileSetMode</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,<A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A> type)</font></strong>
<a name="line542">542: </a>{
<a name="line543">543: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>,<A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A>);

<a name="line547">547: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,<font color="#666666">"PetscViewerFileSetMode_C"</font>,(void (**)(void))&amp;f);
<a name="line548">548: </a>  <font color="#4169E1">if</font> (f) {
<a name="line549">549: </a>    (*f)(viewer,type);
<a name="line550">550: </a>  }
<a name="line551">551: </a>  <font color="#4169E1">return</font>(0);
<a name="line552">552: </a>}

<a name="line557">557: </a><strong><font color="#4169E1"><a name="PetscViewerFileGetMode_Binary"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PetscViewerFileGetMode_Binary(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,<A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A> *type)</font></strong>
<a name="line558">558: </a>{
<a name="line559">559: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line562">562: </a>  *type = vbinary-&gt;btype;
<a name="line563">563: </a>  <font color="#4169E1">return</font>(0);
<a name="line564">564: </a>}

<a name="line570">570: </a><strong><font color="#4169E1"><a name="PetscViewerFileSetMode_Binary"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PetscViewerFileSetMode_Binary(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,<A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A> type)</font></strong>
<a name="line571">571: </a>{
<a name="line572">572: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line575">575: </a>  vbinary-&gt;btype = type;
<a name="line576">576: </a>  <font color="#4169E1">return</font>(0);
<a name="line577">577: </a>}

<a name="line582">582: </a><font color="#B22222">/*@</font>
<a name="line583">583: </a><font color="#B22222">    <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryLoadInfo.html#PetscViewerBinaryLoadInfo">PetscViewerBinaryLoadInfo</A> - Loads options from the name.info file</font>
<a name="line584">584: </a><font color="#B22222">       if it exists.</font>

<a name="line586">586: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A></font>

<a name="line588">588: </a><font color="#B22222">  Input Parameter:</font>
<a name="line589">589: </a><font color="#B22222">.    viewer - the binary viewer whose options you wish to load</font>

<a name="line591">591: </a><font color="#B22222">   Level: developer</font>

<a name="line593">593: </a><font color="#B22222">@*/</font>
<a name="line594">594: </a><strong><font color="#4169E1"><a name="PetscViewerBinaryLoadInfo"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryLoadInfo.html#PetscViewerBinaryLoadInfo">PetscViewerBinaryLoadInfo</A>(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line595">595: </a>{
<a name="line596">596: </a>  FILE               *file;
<a name="line597">597: </a>  char               string[256],*first,*second,*final;
<a name="line598">598: </a>  size_t             len;
<a name="line599">599: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>     ierr;
<a name="line600">600: </a>  <A href="../../../../../docs/manualpages/Sys/PetscToken.html#PetscToken">PetscToken</A>         *token;
<a name="line601">601: </a>  PetscViewer_Binary *vbinary = (PetscViewer_Binary*)viewer-&gt;data;

<a name="line604">604: </a>  <font color="#4169E1">if</font> (vbinary-&gt;skipinfo) <font color="#4169E1">return</font>(0);

<a name="line606">606: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryGetInfoPointer.html#PetscViewerBinaryGetInfoPointer">PetscViewerBinaryGetInfoPointer</A>(viewer,&amp;file);
<a name="line607">607: </a>  <font color="#4169E1">if</font> (!file) <font color="#4169E1">return</font>(0);

<a name="line609">609: </a>  <font color="#B22222">/* read rows of the file adding them to options database */</font>
<a name="line610">610: </a>  <font color="#4169E1">while</font> (fgets(string,256,file)) {
<a name="line611">611: </a>    <font color="#B22222">/* Comments are indicated by #, ! or % in the first column */</font>
<a name="line612">612: </a>    <font color="#4169E1">if</font> (string[0] == '#') <font color="#4169E1">continue</font>;
<a name="line613">613: </a>    <font color="#4169E1">if</font> (string[0] == '!') <font color="#4169E1">continue</font>;
<a name="line614">614: </a>    <font color="#4169E1">if</font> (string[0] == '%') <font color="#4169E1">continue</font>;
<a name="line615">615: </a>    <A href="../../../../../docs/manualpages/Sys/PetscTokenCreate.html#PetscTokenCreate">PetscTokenCreate</A>(string,' ',&amp;token);
<a name="line616">616: </a>    <A href="../../../../../docs/manualpages/Sys/PetscTokenFind.html#PetscTokenFind">PetscTokenFind</A>(token,&amp;first);
<a name="line617">617: </a>    <A href="../../../../../docs/manualpages/Sys/PetscTokenFind.html#PetscTokenFind">PetscTokenFind</A>(token,&amp;second);
<a name="line618">618: </a>    <font color="#4169E1">if</font> (first &amp;&amp; first[0] == '-') {
<a name="line619">619: </a>      <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> wrongtype;
<a name="line620">620: </a>      <font color="#B22222">/*</font>
<a name="line621">621: </a><font color="#B22222">         Check for -mat_complex or -mat_double</font>
<a name="line622">622: </a><font color="#B22222">      */</font>
<a name="line623">623: </a><font color="#A020F0">#if defined(PETSC_USE_COMPLEX)</font>
<a name="line624">624: </a>      <A href="../../../../../docs/manualpages/Sys/PetscStrncmp.html#PetscStrncmp">PetscStrncmp</A>(first,<font color="#666666">"-mat_double"</font>,11,&amp;wrongtype);
<a name="line625">625: </a>      <font color="#4169E1">if</font> (wrongtype) {
<a name="line626">626: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_FILE_UNEXPECTED,<font color="#666666">"Loading double number matrix with complex number code"</font>);
<a name="line627">627: </a>      }
<a name="line628">628: </a><font color="#A020F0">#else</font>
<a name="line629">629: </a>      <A href="../../../../../docs/manualpages/Sys/PetscStrncmp.html#PetscStrncmp">PetscStrncmp</A>(first,<font color="#666666">"-mat_complex"</font>,12,&amp;wrongtype);
<a name="line630">630: </a>      <font color="#4169E1">if</font> (wrongtype) {
<a name="line631">631: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_FILE_UNEXPECTED,<font color="#666666">"Loading complex number matrix with double number code"</font>);
<a name="line632">632: </a>      }
<a name="line633">633: </a><font color="#A020F0">#endif</font>

<a name="line635">635: </a>      <font color="#4169E1">if</font> (second) {final = second;} <font color="#4169E1">else</font> {final = first;}
<a name="line636">636: </a>      <A href="../../../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(final,&amp;len);
<a name="line637">637: </a>      <font color="#4169E1">while</font> (len &gt; 0 &amp;&amp; (final[len-1] == ' ' || final[len-1] == '\n')) {
<a name="line638">638: </a>        len--; final[len] = 0;
<a name="line639">639: </a>      }
<a name="line640">640: </a>      <A href="../../../../../docs/manualpages/Sys/PetscOptionsSetValue.html#PetscOptionsSetValue">PetscOptionsSetValue</A>(first,second);
<a name="line641">641: </a>    }
<a name="line642">642: </a>    <A href="../../../../../docs/manualpages/Sys/PetscTokenDestroy.html#PetscTokenDestroy">PetscTokenDestroy</A>(token);
<a name="line643">643: </a>  }
<a name="line644">644: </a>  <font color="#4169E1">return</font>(0);
<a name="line645">645: </a>}

<a name="line647">647: </a><font color="#B22222">/*</font>
<a name="line648">648: </a><font color="#B22222">        Actually opens the file </font>
<a name="line649">649: </a><font color="#B22222">*/</font>
<a name="line653">653: </a><strong><font color="#4169E1"><a name="PetscViewerFileSetName_Binary"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PetscViewerFileSetName_Binary(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,const char name[])</font></strong>
<a name="line654">654: </a>{
<a name="line655">655: </a>  int                 <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line656">656: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>      ierr;
<a name="line657">657: </a>  size_t              len;
<a name="line658">658: </a>  PetscViewer_Binary  *vbinary = (PetscViewer_Binary*)viewer-&gt;data;
<a name="line659">659: </a>  const char          *fname;
<a name="line660">660: </a>  char                bname[PETSC_MAX_PATH_LEN],*gz;
<a name="line661">661: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>          found;
<a name="line662">662: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A> type = vbinary-&gt;btype;

<a name="line665">665: </a>  <font color="#4169E1">if</font> (type == (<A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A>) -1) {
<a name="line666">666: </a>    <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ORDER,<font color="#666666">"Must call PetscViewerBinarySetFileType() before <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileSetName.html#PetscViewerFileSetName">PetscViewerFileSetName</A>()"</font>);
<a name="line667">667: </a>  }
<a name="line668">668: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetTruth.html#PetscOptionsGetTruth">PetscOptionsGetTruth</A>(viewer-&gt;prefix,<font color="#666666">"-viewer_binary_skip_info"</font>,&amp;vbinary-&gt;skipinfo,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line669">669: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetTruth.html#PetscOptionsGetTruth">PetscOptionsGetTruth</A>(viewer-&gt;prefix,<font color="#666666">"-viewer_binary_skip_options"</font>,&amp;vbinary-&gt;skipoptions,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line671">671: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(viewer-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);

<a name="line673">673: </a>  <font color="#B22222">/* copy name so we can edit it */</font>
<a name="line674">674: </a>  <A href="../../../../../docs/manualpages/Sys/PetscStrallocpy.html#PetscStrallocpy">PetscStrallocpy</A>(name,&amp;vbinary-&gt;filename);

<a name="line676">676: </a>  <font color="#B22222">/* if ends in .gz strip that off and note user wants file compressed */</font>
<a name="line677">677: </a>  vbinary-&gt;storecompressed = <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line678">678: </a>  <font color="#4169E1">if</font> (!<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> &amp;&amp; type == FILE_MODE_WRITE) {
<a name="line679">679: </a>    <font color="#B22222">/* remove .gz if it ends library name */</font>
<a name="line680">680: </a>    <A href="../../../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(vbinary-&gt;filename,<font color="#666666">".gz"</font>,&amp;gz);
<a name="line681">681: </a>    <font color="#4169E1">if</font> (gz) {
<a name="line682">682: </a>      <A href="../../../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(gz,&amp;len);
<a name="line683">683: </a>      <font color="#4169E1">if</font> (len == 3) {
<a name="line684">684: </a>        *gz = 0;
<a name="line685">685: </a>        vbinary-&gt;storecompressed = <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line686">686: </a>      }
<a name="line687">687: </a>    }
<a name="line688">688: </a>  }

<a name="line690">690: </a>  <font color="#B22222">/* only first processor opens file if writeable */</font>
<a name="line691">691: </a>  <font color="#4169E1">if</font> (!<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> || type == FILE_MODE_READ) {

<a name="line693">693: </a>    <font color="#4169E1">if</font> (type == FILE_MODE_READ){
<a name="line694">694: </a>      <font color="#B22222">/* possibly get the file from remote site or compressed file */</font>
<a name="line695">695: </a>      <A href="../../../../../docs/manualpages/Sys/PetscFileRetrieve.html#PetscFileRetrieve">PetscFileRetrieve</A>(viewer-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,vbinary-&gt;filename,bname,PETSC_MAX_PATH_LEN,&amp;found);
<a name="line696">696: </a>      fname = bname;
<a name="line697">697: </a>      <font color="#4169E1">if</font> (!<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> &amp;&amp; !found) {
<a name="line698">698: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_FILE_OPEN,<font color="#666666">"Cannot locate file: %s on node zero"</font>,vbinary-&gt;filename);
<a name="line699">699: </a>      } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (!found) {
<a name="line700">700: </a>        <A href="../../../../../docs/manualpages/Profiling/PetscInfo.html#PetscInfo">PetscInfo</A>(viewer,<font color="#666666">"Nonzero processor did not locate readonly file\n"</font>);
<a name="line701">701: </a>        fname = 0;
<a name="line702">702: </a>      }
<a name="line703">703: </a>    } <font color="#4169E1">else</font> {
<a name="line704">704: </a>      fname = vbinary-&gt;filename;
<a name="line705">705: </a>    }

<a name="line707">707: </a><font color="#A020F0">#if defined(PETSC_HAVE_O_BINARY)</font>
<a name="line708">708: </a>    <font color="#4169E1">if</font> (type == FILE_MODE_WRITE) {
<a name="line709">709: </a>      <font color="#4169E1">if</font> ((vbinary-&gt;fdes = open(fname,O_WRONLY|O_CREAT|O_TRUNC|O_BINARY,0666)) == -1) {
<a name="line710">710: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_FILE_OPEN,<font color="#666666">"Cannot create file %s for writing"</font>,fname);
<a name="line711">711: </a>      }
<a name="line712">712: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (type == FILE_MODE_READ &amp;&amp; fname) {
<a name="line713">713: </a>      <font color="#4169E1">if</font> ((vbinary-&gt;fdes = open(fname,O_RDONLY|O_BINARY,0)) == -1) {
<a name="line714">714: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_FILE_OPEN,<font color="#666666">"Cannot open file %s for reading"</font>,fname);
<a name="line715">715: </a>      }
<a name="line716">716: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (type == FILE_MODE_APPEND) {
<a name="line717">717: </a>      <font color="#4169E1">if</font> ((vbinary-&gt;fdes = open(fname,O_WRONLY|O_BINARY,0)) == -1) {
<a name="line718">718: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_FILE_OPEN,<font color="#666666">"Cannot open file %s for writing"</font>,fname);
<a name="line719">719: </a>      }
<a name="line720">720: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (fname) {
<a name="line721">721: </a>      <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_OUTOFRANGE,<font color="#666666">"Unknown file type"</font>);
<a name="line722">722: </a>    }
<a name="line723">723: </a><font color="#A020F0">#else</font>
<a name="line724">724: </a>    <font color="#4169E1">if</font> (type == FILE_MODE_WRITE) {
<a name="line725">725: </a>      <font color="#4169E1">if</font> ((vbinary-&gt;fdes = creat(fname,0666)) == -1) {
<a name="line726">726: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_FILE_OPEN,<font color="#666666">"Cannot create file %s for writing"</font>,fname);
<a name="line727">727: </a>      }
<a name="line728">728: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (type == FILE_MODE_READ &amp;&amp; fname) {
<a name="line729">729: </a>      <font color="#4169E1">if</font> ((vbinary-&gt;fdes = open(fname,O_RDONLY,0)) == -1) {
<a name="line730">730: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_FILE_OPEN,<font color="#666666">"Cannot open file %s for reading"</font>,fname);
<a name="line731">731: </a>      }
<a name="line732">732: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (type == FILE_MODE_APPEND) {
<a name="line733">733: </a>      <font color="#4169E1">if</font> ((vbinary-&gt;fdes = open(fname,O_WRONLY|O_APPEND,0)) == -1) {
<a name="line734">734: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_FILE_OPEN,<font color="#666666">"Cannot open file %s for writing"</font>,fname);
<a name="line735">735: </a>      }
<a name="line736">736: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (fname) {
<a name="line737">737: </a>      <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_OUTOFRANGE,<font color="#666666">"Unknown file type"</font>);
<a name="line738">738: </a>    }
<a name="line739">739: </a><font color="#A020F0">#endif</font>
<a name="line740">740: </a>  } <font color="#4169E1">else</font> vbinary-&gt;fdes = -1;
<a name="line741">741: </a>  viewer-&gt;format = PETSC_VIEWER_NOFORMAT;

<a name="line743">743: </a>  <font color="#B22222">/* </font>
<a name="line744">744: </a><font color="#B22222">      try to open info file: all processors open this file if read only</font>
<a name="line745">745: </a><font color="#B22222">  */</font>
<a name="line746">746: </a>  <font color="#4169E1">if</font> (!<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> || type == FILE_MODE_READ) {
<a name="line747">747: </a>    char infoname[PETSC_MAX_PATH_LEN],iname[PETSC_MAX_PATH_LEN];
<a name="line748">748: </a>
<a name="line749">749: </a>    <A href="../../../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(infoname,name);
<a name="line750">750: </a>    <font color="#B22222">/* remove .gz if it ends library name */</font>
<a name="line751">751: </a>    <A href="../../../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(infoname,<font color="#666666">".gz"</font>,&amp;gz);
<a name="line752">752: </a>    <font color="#4169E1">if</font> (gz) {
<a name="line753">753: </a>      <A href="../../../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(gz,&amp;len);
<a name="line754">754: </a>      <font color="#4169E1">if</font> (len == 3) {
<a name="line755">755: </a>        *gz = 0;
<a name="line756">756: </a>      }
<a name="line757">757: </a>    }
<a name="line758">758: </a>
<a name="line759">759: </a>    <A href="../../../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(infoname,<font color="#666666">".info"</font>);
<a name="line760">760: </a>    <A href="../../../../../docs/manualpages/Sys/PetscFixFilename.html#PetscFixFilename">PetscFixFilename</A>(infoname,iname);
<a name="line761">761: </a>    <font color="#4169E1">if</font> (type == FILE_MODE_READ) {
<a name="line762">762: </a>      <A href="../../../../../docs/manualpages/Sys/PetscFileRetrieve.html#PetscFileRetrieve">PetscFileRetrieve</A>(viewer-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,iname,infoname,PETSC_MAX_PATH_LEN,&amp;found);
<a name="line763">763: </a>      <font color="#4169E1">if</font> (found) {
<a name="line764">764: </a>        vbinary-&gt;fdes_info = fopen(infoname,<font color="#666666">"r"</font>);
<a name="line765">765: </a>        <font color="#4169E1">if</font> (vbinary-&gt;fdes_info) {
<a name="line766">766: </a>          <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryLoadInfo.html#PetscViewerBinaryLoadInfo">PetscViewerBinaryLoadInfo</A>(viewer);
<a name="line767">767: </a>          fclose(vbinary-&gt;fdes_info);
<a name="line768">768: </a>        }
<a name="line769">769: </a>        vbinary-&gt;fdes_info = fopen(infoname,<font color="#666666">"r"</font>);
<a name="line770">770: </a>      }
<a name="line771">771: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (!vbinary-&gt;skipinfo) {
<a name="line772">772: </a>      vbinary-&gt;fdes_info = fopen(infoname,<font color="#666666">"w"</font>);
<a name="line773">773: </a>      <font color="#4169E1">if</font> (!vbinary-&gt;fdes_info) {
<a name="line774">774: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_FILE_OPEN,<font color="#666666">"Cannot open .info file %s for writing"</font>,infoname);
<a name="line775">775: </a>      }
<a name="line776">776: </a>    }
<a name="line777">777: </a>  }

<a name="line779">779: </a><font color="#A020F0">#if defined(PETSC_USE_LOG)</font>
<a name="line780">780: </a>  PetscLogObjectState((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,<font color="#666666">"File: %s"</font>,name);
<a name="line781">781: </a><font color="#A020F0">#endif</font>
<a name="line782">782: </a>  <font color="#4169E1">return</font>(0);
<a name="line783">783: </a>}

<a name="line789">789: </a><strong><font color="#4169E1"><a name="PetscViewerCreate_Binary"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PetscViewerCreate_Binary(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> v)</font></strong>
<a name="line790">790: </a>{
<a name="line791">791: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>     ierr;
<a name="line792">792: </a>  PetscViewer_Binary *vbinary;

<a name="line795">795: </a>  <A href="../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(PetscViewer_Binary,&amp;vbinary);
<a name="line796">796: </a>  v-&gt;data            = (void*)vbinary;
<a name="line797">797: </a>  v-&gt;ops-&gt;destroy    = PetscViewerDestroy_Binary;
<a name="line798">798: </a>  v-&gt;ops-&gt;flush      = 0;
<a name="line799">799: </a>  v-&gt;iformat         = 0;
<a name="line800">800: </a>  vbinary-&gt;fdes_info = 0;
<a name="line801">801: </a>  vbinary-&gt;fdes      = 0;
<a name="line802">802: </a>  vbinary-&gt;skipinfo        = <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line803">803: </a>  vbinary-&gt;skipoptions     = <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line804">804: </a>  v-&gt;ops-&gt;getsingleton     = PetscViewerGetSingleton_Binary;
<a name="line805">805: </a>  v-&gt;ops-&gt;restoresingleton = PetscViewerRestoreSingleton_Binary;
<a name="line806">806: </a>  vbinary-&gt;btype           = (<A href="../../../../../docs/manualpages/Sys/PetscFileMode.html#PetscFileMode">PetscFileMode</A>) -1;
<a name="line807">807: </a>  vbinary-&gt;storecompressed = <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line808">808: </a>  vbinary-&gt;filename        = 0;

<a name="line810">810: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)v,<font color="#666666">"PetscViewerFileSetName_C"</font>,
<a name="line811">811: </a>                                    <font color="#666666">"PetscViewerFileSetName_Binary"</font>,
<a name="line812">812: </a>                                     PetscViewerFileSetName_Binary);
<a name="line813">813: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)v,<font color="#666666">"PetscViewerFileSetMode_C"</font>,
<a name="line814">814: </a>                                    <font color="#666666">"PetscViewerFileSetMode_Binary"</font>,
<a name="line815">815: </a>                                     PetscViewerFileSetMode_Binary);
<a name="line816">816: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)v,<font color="#666666">"PetscViewerFileGetMode_C"</font>,
<a name="line817">817: </a>                                    <font color="#666666">"PetscViewerFileGetMode_Binary"</font>,
<a name="line818">818: </a>                                     PetscViewerFileGetMode_Binary);
<a name="line819">819: </a>  <font color="#4169E1">return</font>(0);
<a name="line820">820: </a>}


<a name="line824">824: </a><font color="#B22222">/* ---------------------------------------------------------------------*/</font>
<a name="line825">825: </a><font color="#B22222">/*</font>
<a name="line826">826: </a><font color="#B22222">    The variable Petsc_Viewer_Binary_keyval is used to indicate an MPI attribute that</font>
<a name="line827">827: </a><font color="#B22222">  is attached to a communicator, in this case the attribute is a <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>.</font>
<a name="line828">828: </a><font color="#B22222">*/</font>
<a name="line829">829: </a>static int Petsc_Viewer_Binary_keyval = MPI_KEYVAL_INVALID;

<a name="line833">833: </a><font color="#B22222">/*@C</font>
<a name="line834">834: </a><font color="#B22222">     <A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A> - Creates a binary <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> shared by all processors </font>
<a name="line835">835: </a><font color="#B22222">                     in a communicator.</font>

<a name="line837">837: </a><font color="#B22222">     Collective on <A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A></font>

<a name="line839">839: </a><font color="#B22222">     Input Parameter:</font>
<a name="line840">840: </a><font color="#B22222">.    <A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A> - the MPI communicator to share the binary <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A></font>
<a name="line841">841: </a><font color="#B22222">    </font>
<a name="line842">842: </a><font color="#B22222">     Level: intermediate</font>

<a name="line844">844: </a><font color="#B22222">   Options Database Keys:</font>
<a name="line845">845: </a><font color="#B22222">$    -viewer_binary_filename &lt;name&gt;</font>

<a name="line847">847: </a><font color="#B22222">   Environmental variables:</font>
<a name="line848">848: </a><font color="#B22222">-   PETSC_VIEWER_BINARY_FILENAME</font>

<a name="line850">850: </a><font color="#B22222">     Notes:</font>
<a name="line851">851: </a><font color="#B22222">     Unlike almost all other PETSc routines, <A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A> does not return </font>
<a name="line852">852: </a><font color="#B22222">     an error code.  The binary <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> is usually used in the form</font>
<a name="line853">853: </a><font color="#B22222">$       XXXView(XXX object,<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A>(<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>));</font>

<a name="line855">855: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_WORLD.html#PETSC_VIEWER_BINARY_WORLD">PETSC_VIEWER_BINARY_WORLD</A>, <A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_SELF.html#PETSC_VIEWER_BINARY_SELF">PETSC_VIEWER_BINARY_SELF</A>, <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerCreate.html#PetscViewerCreate">PetscViewerCreate</A>(),</font>
<a name="line856">856: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>()</font>
<a name="line857">857: </a><font color="#B22222">@*/</font>
<a name="line858">858: </a><strong><font color="#4169E1"><a name="PETSC_VIEWER_BINARY_"></a><A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>  <A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A>(<A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A> <A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>)</font></strong>
<a name="line859">859: </a>{
<a name="line861">861: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;
<a name="line862">862: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>    viewer;
<a name="line863">863: </a>  char           fname[PETSC_MAX_PATH_LEN];

<a name="line866">866: </a>  <font color="#4169E1">if</font> (Petsc_Viewer_Binary_keyval == MPI_KEYVAL_INVALID) {
<a name="line867">867: </a>    <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Keyval_create.html#MPI_Keyval_create">MPI_Keyval_create</A>(<A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_NULL_COPY_FN.html#MPI_NULL_COPY_FN">MPI_NULL_COPY_FN</A>,<A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_NULL_DELETE_FN.html#MPI_NULL_DELETE_FN">MPI_NULL_DELETE_FN</A>,&amp;Petsc_Viewer_Binary_keyval,0);
<a name="line868">868: </a>    <font color="#4169E1">if</font> (ierr) {<A href="../../../../../docs/manualpages/Sys/PetscError.html#PetscError">PetscError</A>(__LINE__,<font color="#666666">"<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A>"</font>,__FILE__,__SDIR__,1,1,<font color="#666666">" "</font>);<font color="#4169E1">return</font>(0);}
<a name="line869">869: </a>  }
<a name="line870">870: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Attr_get.html#MPI_Attr_get">MPI_Attr_get</A>(<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,Petsc_Viewer_Binary_keyval,(void **)&amp;viewer,(int*)&amp;flg);
<a name="line871">871: </a>  <font color="#4169E1">if</font> (ierr) {<A href="../../../../../docs/manualpages/Sys/PetscError.html#PetscError">PetscError</A>(__LINE__,<font color="#666666">"<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A>"</font>,__FILE__,__SDIR__,1,1,<font color="#666666">" "</font>);<font color="#4169E1">return</font>(0);}
<a name="line872">872: </a>  <font color="#4169E1">if</font> (!flg) { <font color="#B22222">/* <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> not yet created */</font>
<a name="line873">873: </a>    <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetenv.html#PetscOptionsGetenv">PetscOptionsGetenv</A>(<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,<font color="#666666">"PETSC_VIEWER_BINARY_FILENAME"</font>,fname,PETSC_MAX_PATH_LEN,&amp;flg);
<a name="line874">874: </a>    <font color="#4169E1">if</font> (ierr) {<A href="../../../../../docs/manualpages/Sys/PetscError.html#PetscError">PetscError</A>(__LINE__,<font color="#666666">"<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A>"</font>,__FILE__,__SDIR__,1,1,<font color="#666666">" "</font>);<font color="#4169E1">return</font>(0);}
<a name="line875">875: </a>    <font color="#4169E1">if</font> (!flg) {
<a name="line876">876: </a>      <A href="../../../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(fname,<font color="#666666">"binaryoutput"</font>);
<a name="line877">877: </a>      <font color="#4169E1">if</font> (ierr) {<A href="../../../../../docs/manualpages/Sys/PetscError.html#PetscError">PetscError</A>(__LINE__,<font color="#666666">"<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A>"</font>,__FILE__,__SDIR__,1,1,<font color="#666666">" "</font>);<font color="#4169E1">return</font>(0);}
<a name="line878">878: </a>    }
<a name="line879">879: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,fname,FILE_MODE_WRITE,&amp;viewer);
<a name="line880">880: </a>    <font color="#4169E1">if</font> (ierr) {<A href="../../../../../docs/manualpages/Sys/PetscError.html#PetscError">PetscError</A>(__LINE__,<font color="#666666">"<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A>"</font>,__FILE__,__SDIR__,1,1,<font color="#666666">" "</font>);<font color="#4169E1">return</font>(0);}
<a name="line881">881: </a>    <A href="../../../../../docs/manualpages/Sys/PetscObjectRegisterDestroy.html#PetscObjectRegisterDestroy">PetscObjectRegisterDestroy</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer);
<a name="line882">882: </a>    <font color="#4169E1">if</font> (ierr) {<A href="../../../../../docs/manualpages/Sys/PetscError.html#PetscError">PetscError</A>(__LINE__,<font color="#666666">"<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A>"</font>,__FILE__,__SDIR__,1,1,<font color="#666666">" "</font>);<font color="#4169E1">return</font>(0);}
<a name="line883">883: </a>    <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Attr_put.html#MPI_Attr_put">MPI_Attr_put</A>(<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,Petsc_Viewer_Binary_keyval,(void*)viewer);
<a name="line884">884: </a>    <font color="#4169E1">if</font> (ierr) {<A href="../../../../../docs/manualpages/Sys/PetscError.html#PetscError">PetscError</A>(__LINE__,<font color="#666666">"<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_BINARY_.html#PETSC_VIEWER_BINARY_">PETSC_VIEWER_BINARY_</A>"</font>,__FILE__,__SDIR__,1,1,<font color="#666666">" "</font>);<font color="#4169E1">return</font>(0);}
<a name="line885">885: </a>  }
<a name="line886">886: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFunctionReturn.html#PetscFunctionReturn">PetscFunctionReturn</A>(viewer);
<a name="line887">887: </a>}







</pre>
</body>

</html>
